#!/bin/bash
set -ex

source charms.reactive.sh

juju-log "IBM MQ: Begin"

@when_not 'prod.installed'
function tt() {
	apt-get -y update
	set_state 'prod.installed'
	status-set active "wasdummy installed successfully"
}

@when 'prod.installed'
@when 'wasmessaging.connected'
function set_hostname(){

	juju-log "IBM WAS dummy: *******In set_hostname reactive function of WAS dummy charm*******"
	hostname=`unit-get private-address`
        relation_call --state=wasmessaging.connected set_hostname $hostname || true
}
@when 'prod.installed'
@when 'wasmessaging.ready' 
function get_mq_instance_details(){
        juju-log "IBM WAS dummy: *******In get_mq_instance_details reactive function of WAS dummy charm*******"
        port=$(relation_call --state=wasmessaging.connected get_mq_port) || true
        if [ -z "$port" ]; then
                juju-log "IBM WAS dummy: No MQ data sent yet"
                return 0
        fi
        QM_Name=$(relation_call --state=wasmessaging.connected get_qm_name) || true
        hostname=$(relation_call --state=wasmessaging.connected get_mq_hostname) || true
        Qname=$(relation_call --state=wasmessaging.connected get_qname) || true
        status-set active "IBM WAS dummy: Got MQ instance details."
        juju-log "IBM WAS dummy: values of MQ in WAS Charm port=$port QM_Name=$QM_Name hostname=$hostname Qname=$Qname"
        set_state 'ibm-was-dummy.mq.available'
}
reactive_handler_main
